<template>
  <div class="full-width full-height" :id="mapName"></div>
</template>

<script>
import EventBus from '../eventbus';
import {mapGetters} from 'vuex';

export default {
  name: 'google-map',
  props: ['name'],
  data: function () {
        return {
          mapName: this.name + "-map",
          map:'',
          mapmarker:[],
          directionsService:'',
          directionsDisplay:'',
          bounds : '',
          data_layer: '',
          markerLayer:new google.maps.Marker(),
        }
      },
    title : []
    ,
  mounted: function () {

    // map = this.map;

    const element = document.getElementById(this.mapName)
    const options = {
      center: {lat: -6.889872, lng: 107.610781},
      zoom: 17,
      styles : 
          [
            {
              "elementType": "geometry",
              "stylers": [
                {
                  "color": "#f5f5f5"
                }
              ]
            },
            {
              "elementType": "labels",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "elementType": "labels.icon",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "elementType": "labels.text.fill",
              "stylers": [
                {
                  "color": "#616161"
                }
              ]
            },
            {
              "elementType": "labels.text.stroke",
              "stylers": [
                {
                  "color": "#f5f5f5"
                }
              ]
            },
            {
              "featureType": "administrative",
              "elementType": "geometry",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "administrative.land_parcel",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "administrative.land_parcel",
              "elementType": "labels.text.fill",
              "stylers": [
                {
                  "color": "#bdbdbd"
                }
              ]
            },
            {
              "featureType": "administrative.neighborhood",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "poi",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "poi",
              "elementType": "geometry",
              "stylers": [
                {
                  "color": "#eeeeee"
                }
              ]
            },
            {
              "featureType": "poi",
              "elementType": "labels.text.fill",
              "stylers": [
                {
                  "color": "#757575"
                }
              ]
            },
            {
              "featureType": "poi.park",
              "elementType": "geometry",
              "stylers": [
                {
                  "color": "#e5e5e5"
                }
              ]
            },
            {
              "featureType": "poi.park",
              "elementType": "labels.text.fill",
              "stylers": [
                {
                  "color": "#9e9e9e"
                }
              ]
            },
            {
              "featureType": "road",
              "elementType": "geometry",
              "stylers": [
                {
                  "color": "#ffffff"
                }
              ]
            },
            {
              "featureType": "road",
              "elementType": "labels.icon",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "road.arterial",
              "elementType": "labels",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "road.arterial",
              "elementType": "labels.text.fill",
              "stylers": [
                {
                  "color": "#757575"
                }
              ]
            },
            {
              "featureType": "road.highway",
              "elementType": "geometry",
              "stylers": [
                {
                  "color": "#dadada"
                }
              ]
            },
            {
              "featureType": "road.highway",
              "elementType": "labels",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "road.highway",
              "elementType": "labels.text.fill",
              "stylers": [
                {
                  "color": "#616161"
                }
              ]
            },
            {
              "featureType": "road.local",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "road.local",
              "elementType": "labels.text.fill",
              "stylers": [
                {
                  "color": "#9e9e9e"
                }
              ]
            },
            {
              "featureType": "transit",
              "stylers": [
                {
                  "visibility": "off"
                }
              ]
            },
            {
              "featureType": "transit.line",
              "elementType": "geometry",
              "stylers": [
                {
                  "color": "#e5e5e5"
                }
              ]
            },
            {
              "featureType": "transit.station",
              "elementType": "geometry",
              "stylers": [
                {
                  "color": "#eeeeee"
                }
              ]
            },
            {
              "featureType": "water",
              "elementType": "geometry",
              "stylers": [
                {
                  "color": "#c9c9c9"
                }
              ]
            },
            {
              "featureType": "water",
              "elementType": "labels.text.fill",
              "stylers": [
                {
                  "color": "#9e9e9e"
                }
              ]
            }
          ], 
          mapTypeControl: false
    }

    this.map = new google.maps.Map(element, options);
    this.directionsService = new google.maps.DirectionsService;
    this.directionsDisplay = new google.maps.DirectionsRenderer;
    
    this.data_layer = new google.maps.Data({map: this.map});
    const data_layer_2 = new google.maps.Data({map: this.map});
    const data_layer_3 = new google.maps.Data({map: this.map});
    const data_layer_4 = new google.maps.Data({map: this.map});
    const data_layer_5 = new google.maps.Data({map: this.map});
    const data_layer_6 = new google.maps.Data({map: this.map});
    const data_layer_7 = new google.maps.Data({map: this.map});
    const data_layer_8 = new google.maps.Data({map: this.map});
    const data_layer_9 = new google.maps.Data({map: this.map});

    this.data_layer.loadGeoJson('http://campusgis-svc.test/informasispasial/bangunan');
    data_layer_2.loadGeoJson('http://campusgis-svc.test/informasispasial/jalan');
    // // data_layer_3.loadGeoJson('http://campusgis-svc.test/informasispasial/kolam');
    data_layer_4.loadGeoJson('http://campusgis-svc.test/informasispasial/kolamsaraga');
    // // data_layer_5.loadGeoJson('http://campusgis-svc.test/informasispasial/gardu');
    // // data_layer_6.loadGeoJson('http://campusgis-svc.test/informasispasial/koridor');
    // // data_layer_7.loadGeoJson('http://campusgis-svc.test/informasispasial/parkiran');
    data_layer_8.loadGeoJson('http://campusgis-svc.test/informasispasial/taman');
    data_layer_9.loadGeoJson('http://campusgis-svc.test/informasispasial/lapangan');

    // data_layer.loadGeoJson('http://campusgis-svc.test/api/v2/informasispasial/');


    this.data_layer.setStyle({
      fillColor: 'yellow',
      strokeWeight: 1
    });

    data_layer_2.setStyle({
      fillColor: 'grey',
      strokeWeight: 1
    });

    data_layer_6.setStyle({
      fillColor: 'red',
      strokeWeight: 1
    });

    data_layer_7.setStyle({
      fillColor: 'blue',
      strokeWeight: 1
    });

    data_layer_8.setStyle({
      fillColor: 'green',
      strokeWeight: 1
    });

    data_layer_9.setStyle({
      fillColor: 'darkgreen',
      strokeWeight: 1
    });

    this.data_layer.addListener('click', function(event) {

      // console.log(event.feature.getProperty('lat'));
      // this.$store.dispatch('getPoint',event.feature.getProperty('objectid'));
      // this.$store.dispatch('getPoint', event.feature.getProperty('id'));
      EventBus.$emit('detail',event.feature.getProperty('id')); 

      EventBus.$emit('markerLayer',event);
      
    });

  },
  created() {
    EventBus.$on('markers', this.addMarker);
    EventBus.$on('markersParkiran', this.addMarkerParkiran);
    EventBus.$on('markerLayer', this.addMarkerLayer);
    EventBus.$on('location',this.getDirection);
    EventBus.$on('resetDisplay',this.resetDisplay);

    // EventBus.$on('toggleBounce',this.toggleBounce);
  },
  beforeDestroy() {
    EventBus.$off('markers');
    EventBus.$off('markersParkiran');
    EventBus.$off('markerLayer');
    EventBus.$off('location');
    EventBus.$off('resetDisplay');
    // EventBus.$off('toggleBounce');
  },
  methods: {
    resetDisplay: function(){
      
      this.deleteMarkers();

      if (this.directionsDisplay && this.directionsDisplay.setMap){
         this.directionsDisplay.setMap(null);
      }
    },
    setMapOnAll: function(map) {
      for (var i = 0; i < this.mapmarker.length; i++) {
        this.mapmarker[i].setMap(map);
      }
    },
    clearMarkers: function () {
        this.setMapOnAll(null);
    },
    deleteMarkers: function () {
      this.clearMarkers();
      this.mapmarker = [];
    },
    showMarkers: function () {
        this.setMapOnAll(this.map);
        this.map.fitBounds(this.bounds);
        this.map.panToBounds(this.bounds);
    },
    addMarker(markers){
      console.log(markers);
      this.bounds = new google.maps.LatLngBounds();

      for (var i=0; i < markers.length; i++) {
        var marker = new google.maps.Marker({
            // map: this.map,
            animation: google.maps.Animation.DROP,
            position: {lat: parseFloat(markers[i].lat), lng: parseFloat(markers[i].lng)},
            // label: String(markers[i].id),
            customid: markers[i].id,
            customobjectid : markers[i].objectid,
            customtype : markers[i].type,
          });
         // marker.addListener('click', this.toggleBounce);
         
         // this.mapmarker[i].addListener('click', this.toggleBounce);

        // google.maps.event.addListener(marker, 'click', function () {
        //     if (marker.getAnimation() !== null) {
        //         marker.setAnimation(null);
        //     } else {
        //         marker.setAnimation(google.maps.Animation.BOUNCE);
        //     }            
        // });
        this.bounds.extend({lat: parseFloat(markers[i].lat), lng: parseFloat(markers[i].lng)});
        this.mapmarker.push(marker);
      }
      this.showMarkers();
      // this.mapmarker.setMap(this.map);
      
    },
    addMarkerLayer(event){
      console.log(event.feature.getProperty('lat'));
      this.bounds = new google.maps.LatLngBounds();

      this.markerLayer.setMap(null);

      console.log(this.markerLayer);

      this.markerLayer.setPosition({lat: parseFloat(event.feature.getProperty('lat')), lng: parseFloat(event.feature.getProperty('lng'))});

      this.markerLayer.setMap(this.map);
      
    },
    addMarkerParkiran(markers){
      // console.log(markers);
      for (var i=0; i < markers.length; i++) {
        var marker = new google.maps.Marker({
            // map: this.map,
            // animation: google.maps.Animation.DROP,
            position: {lat: parseFloat(markers[i].lat), lng: parseFloat(markers[i].lng)},
            label: String(markers[i].remain),
            customid: markers[i].id,
            customobjectid : markers[i].objectid,
            customtype : markers[i].type,
          });
        this.bounds.extend({lat: parseFloat(markers[i].lat), lng: parseFloat(markers[i].lng)});
        this.mapmarker.push(marker);
      }

      this.showMarkers();
      
    },
    toggleBounce: function(marker) {

      // for (var i=0; i < this.mapmarker.length; i++) {

      //   if(this.mapmarker[i].customid = marker.id){
          if (this.mapmarker.getAnimation() !== null) {
            this.mapmarker.setAnimation(null);
          } else {
            this.mapmarker.setAnimation(google.maps.Animation.BOUNCE);
          }
      //   }
      // }
    },
    getDirection: function(location){
      if(location.origin.id && location.destination.id){
        this.directionsDisplay.setMap(this.map);
        this.calculateAndDisplayRoute(this.directionsService, this.directionsDisplay,location);
      }
    },
    calculateAndDisplayRoute: function(directionsService, directionsDisplay,location) {
        directionsService.route({
          origin: new google.maps.LatLng(location.origin.lat, location.origin.lng),
          destination: new google.maps.LatLng(location.destination.lat, location.destination.lng),
          travelMode: 'WALKING'
        }, function(response, status) {
          if (status === 'OK') {
            directionsDisplay.setDirections(response);
          } else {
            window.alert('Directions request failed due to ' + status);
          }
        });
      }
  },
  computed: {
        ...mapGetters([
            'points','datapoint'
        ])
  }
};
</script>